<?php

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

class CosmicBlocks_Shortcodes
{
	public function __construct()
	{
		add_shortcode('cwp_social_share', [$this, 'cwp_social_share_shortcode']);
		add_shortcode('cwp_posts_list', [$this, 'cwp_posts_list_shortcode']);
		add_shortcode('cwp_posts_tiles', [$this, 'cwp_posts_tiles_shortcode']);
	}
	
	function cwp_social_share_shortcode($atts)
	{
		$columns = '1';
		if(!empty($atts['columns'])) { $columns = $atts['columns']; }

		$html = '';
		//$html .= '<pre>'.print_r($atts, true).'</pre>';
		$html .= '<div class="cwp-main-wrapper cwp-'.$columns.'-column'.(!empty($atts['positionclass']) ? ' '.$atts['positionclass'] : '').'">';
			$html .= '<div class="cwp-inner-wrap">';
				$html .= '<div class="cwp-content-wrap">';
					$html .= '<div class="cwp-buttons-wrap">';
						if((!empty($atts['facebook']) && $atts['facebook'] === '1'))
						{
							$html .= '<div class="cwp-button-wrap">';
								$html .= '<a class="'.$atts['buttonstyle'].'" href="https://www.facebook.com/sharer/sharer.php?u='.urlencode(get_permalink()).'">';
									$html .= (($atts['buttontype'] ==='icon' || $atts['buttontype'] ==='text_icon') ? '<i class="fa fa-facebook"></i>' : '').(($atts['buttontype'] ==='text' || $atts['buttontype'] ==='text_icon') ? '<span>'.__('Facebook', 'cosmic-blocks').'</span>' : '');
								$html .= '</a>';
							$html .= '</div>';
						}
						if(!empty($atts['twitter']) && $atts['twitter'] === '1')
						{
							$html .= '<div class="cwp-button-wrap">';
								$html .= '<a class="'.$atts['buttonstyle'].'" href="https://twitter.com/intent/tweet?status='.urlencode(substr(get_the_title(), 0, 240 - mb_strlen(get_permalink(), 'UTF-8')).' '.get_permalink()).'">';
									$html .= (($atts['buttontype'] ==='icon' || $atts['buttontype'] ==='text_icon') ? '<i class="fa fa-twitter"></i>' : '').(($atts['buttontype'] ==='text' || $atts['buttontype'] ==='text_icon') ? '<span>'.__('Twitter', 'cosmic-blocks').'</span>' : '');
								$html .= '</a>';
							$html .= '</div>';
						}
						if(!empty($atts['linkedin']) && $atts['linkedin'] === '1')
						{
							$html .= '<div class="cwp-button-wrap">';
								$html .= '<a class="'.$atts['buttonstyle'].'" href="http://www.linkedin.com/shareArticle?mini=true&url='.urlencode(get_permalink()).'&title='.urlencode(get_the_title()).'&summary='.urlencode('').'">';
								$html .= (($atts['buttontype'] ==='icon' || $atts['buttontype'] ==='text_icon') ? '<i class="fa fa-linkedin"></i>' : '').(($atts['buttontype'] ==='text' || $atts['buttontype'] ==='text_icon') ? '<span>'.__('LinkedIn', 'cosmic-blocks').'</span>' : '');
								$html .= '</a>';
							$html .= '</div>';
						}
						if(!empty($atts['xing']) && $atts['xing'] === '1')
						{
							$html .= '<div class="cwp-button-wrap">';
								$html .= '<a class="'.$atts['buttonstyle'].'" href="https://www.xing.com/social_plugins/share/new?h=1&url='.urlencode(get_permalink()).'">';
									$html .= (($atts['buttontype'] ==='icon' || $atts['buttontype'] ==='text_icon') ? '<i class="fa fa-xing"></i>' : '').(($atts['buttontype'] ==='text' || $atts['buttontype'] ==='text_icon') ? '<span>'.__('Xing', 'cosmic-blocks').'</span>' : '');
								$html .= '</a>';
							$html .= '</div>';
						}
						if(!empty($atts['whatsapp']) && $atts['whatsapp'] === '1')
						{
							$html .= '<div class="cwp-button-wrap">';
								$html .= '<a class="'.$atts['buttonstyle'].'" href="https://api.whatsapp.com/send?text='.__('I recommend this article to you:', 'cosmic-blocks').' '.get_the_title().' '.get_permalink().'">';
									$html .= (($atts['buttontype'] ==='icon' || $atts['buttontype'] ==='text_icon') ? '<i class="fa fa-whatsapp"></i>' : '').(($atts['buttontype'] ==='text' || $atts['buttontype'] ==='text_icon') ? '<span>'.__('WhatsApp', 'cosmic-blocks').'</span>' : '');
								$html .= '</a>';
							$html .= '</div>';
						}
					$html .= '</div>';
				$html .= '</div>';
			$html .= '</div>';
		$html .= '</div>';
		return $html;
	}
	
	function cwp_posts_list_shortcode($atts)
	{
		$page = isset($_GET['cwp-bpl-page']) ? abs((int)$_GET['cwp-bpl-page']) : 1;
		
		$postslist = new WP_Query([
			'posts_per_page' => $atts['postsperpage'],
			'cat' => $atts['selectedcategory'],
			'category__not_in' => $atts['excludedcategory'],
			'paged' => $page,
			'post_type' => 'post',
			'order' => $atts['order'],
			'orderby' => $atts['orderby']
		]);

		// style
		$cwpContentWrapStyle = '';
		
		if(isset($atts['color'])) { $cwpContentWrapStyle .= 'background:'.$atts['color'].';'; }
		if(isset($atts['boxradiusfix']) && $atts['boxradiusfix'] === '1' && isset($atts['boxradius']) && $atts['boxradius'] >= 0 ) { $cwpContentWrapStyle .= 'border-radius:'.$atts['boxradius'].'px;'; }
		else if(isset($atts['boxradius']) && $atts['boxradius'] > 0 ) { $cwpContentWrapStyle .= 'border-radius:'.$atts['boxradius'].'px;'; }
		if(isset($atts['boxradiusfix']) && $atts['boxradiusfix'] === '1' && isset($atts['boxpadding']) && $atts['boxpadding'] >= 0 ) { $cwpContentWrapStyle .= 'padding:'.$atts['boxpadding'].'px;'; }
		else if(isset($atts['boxpadding']) && $atts['boxpadding'] > 0 ) { $cwpContentWrapStyle .= 'padding:'.$atts['boxpadding'].'px;'; }

		$columns = '1';
		if(!empty($atts['columns'])) { $columns = $atts['columns']; }

		$html = '';
		if($postslist->have_posts())
		{
			$html .= '<div class="cwp-main-wrapper cwp-'.$columns.'-column'.(!empty($atts['startclass']) ? ' '.$atts['startclass'] : '').'">';
				while($postslist->have_posts())
				{
					$postslist->the_post(); 
					$postmeta = get_post_meta(get_the_ID());

					$html .= '<div class="cwp-inner-wrap">';
						$html .= '<div class="cwp-content-wrap '.(!empty($atts['color']) ? 'cwp-content-wrap-has-background' : '').'" style="'.$cwpContentWrapStyle.'">';
							$html .= '<div class="cwp-content-wrap-inner">';
								$html .= '<div class="cwp-list-item">';
								
									if($atts['position'] === 'before')
									{
										if($atts['showtitle'] === '1')
										{
											$html .= '<h3'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'>';
												if(!empty(get_the_content())) { $html .= '<a href="'.get_permalink().'">'; }
													$html .= get_the_title();
												if(!empty(get_the_content())) { $html .= '</a>'; }
											$html .= '</h3>';	
										}
										if($atts['showdate'] === '1' || $atts['showauthor'] === '1')
										{
											$html .= '<div class="cwp-post-meta">';
												if($atts['showdate'] === '1') { $html .= '<span class="cwp-post-meta-date"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'><i class="fa fa-calendar"></i> '.date_i18n(get_option('date_format'), get_the_date('U')).'</span>'; }
												if($atts['showdate'] === '1' && $atts['showauthor'] === '1') { $html .= '<span class="cwp-post-meta-sep"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'>|</span>'; }
												if($atts['showauthor'] === '1') { $html .= '<span class="cwp-post-meta-author"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'><a href="'.get_author_posts_url(get_the_author_meta('ID')).'"><i class="fa fa-user"></i> '.get_the_author().'</a></span>'; }
											$html .= '</div>';
										}
									}

									if($atts['showimage'] === '1')
									{
										$html .= '<div class="cwp-post-main">';
											$html .= '<div class="cwp-post-main-image">';
												if(!empty(get_the_content())) { $html .= '<a href="'.get_permalink().'">'; }
													$postUrl = get_the_post_thumbnail_url(get_the_ID(), $atts['imagesize']);
													if($postUrl) { $html .= '<img src="'.$postUrl.'">'; }
													else { $html .= '<img src="'.COSMIC_BLOCKS_PLUGIN_URL.'/assets/images/no-post.jpg">'; }
												if(!empty(get_the_content())) { $html .= '</a>'; }
											$html .= '</div>';
											$html .= '<div class="cwp-post-main-text">';
												if($atts['position'] === 'inside')
												{
													if($atts['showtitle'] === '1')
													{
														$html .= '<h3'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'>';
															if(!empty(get_the_content())) { $html .= '<a href="'.get_permalink().'">'; }
																$html .= get_the_title();
															if(!empty(get_the_content())) { $html .= '</a>'; }
														$html .= '</h3>';	
													}
													if($atts['showdate'] === '1' || $atts['showauthor'] === '1')
													{
														$html .= '<div class="cwp-post-meta">';
															if($atts['showdate'] === '1') { $html .= '<span class="cwp-post-meta-date"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'><i class="fa fa-calendar"></i> '.date_i18n(get_option('date_format'), get_the_date('U')).'</span>'; }
															if($atts['showdate'] === '1' && $atts['showauthor'] === '1') { $html .= '<span class="cwp-post-meta-sep"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'>|</span>'; }
															if($atts['showauthor'] === '1') { $html .= '<span class="cwp-post-meta-author"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'><a href="'.get_author_posts_url(get_the_author_meta('ID')).'"><i class="fa fa-user"></i> '.get_the_author().'</a></span>'; }
														$html .= '</div>';
													}
												}

												if($atts['showexcerpt'] === '1')
												{
													$html .= '<div class="cwp-post-main-text-excerpt"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'>';
														if(!empty(get_the_excerpt())) { $html .= get_the_excerpt(); }
														else { $html .= wp_trim_words(get_the_content(), 120); }
													$html .= '</div>';
												}
												
												if($atts['showcontent'] === '1')
												{
													$html .= '<div class="cwp-post-main-text-content"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'>';
														$html .= get_the_content();
													$html .= '</div>';
												}

												if(!empty(get_the_content()) && $atts['showbutton'] === 'yes')
												{
													$html .= '<div class="cwp-post-main-text-buttons">';
														$html .= '<a href="'.get_permalink().'" class="'.$atts['showbuttonstyle'].'" target="'.$atts['showbuttontarget'].'">'.html_entity_decode($atts['showbuttontext']).'</a>';
													$html .= '</div>';
												}
											$html .= '</div>';
										$html .= '</div>';
									}
									else
									{
										$html .= '<div class="cwp-post-main">';
											$html .= '<div class="cwp-post-main-text cwp-post-main-text-full">';
												if($atts['position'] === 'inside')
												{
													if($atts['showtitle'] === '1')
													{
														$html .= '<h3'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'>';
															if(!empty(get_the_content())) { $html .= '<a href="'.get_permalink().'">'; }
																$html .= get_the_title();
															if(!empty(get_the_content())) { $html .= '</a>'; }
														$html .= '</h3>';	
													}

													if($atts['showdate'] === '1' || $atts['showauthor'] === '1')
													{
														$html .= '<div class="cwp-post-meta">';
															if($atts['showdate'] === '1') { $html .= '<span class="cwp-post-meta-date"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'><i class="fa fa-calendar"></i> '.date_i18n(get_option('date_format'), get_the_date('U')).'</span>'; }
															if($atts['showdate'] === '1' && $atts['showauthor'] === '1') { $html .= '<span class="cwp-post-meta-sep"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'>|</span>'; }
															if($atts['showauthor'] === '1') { $html .= '<span class="cwp-post-meta-author"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'><a href="'.get_author_posts_url(get_the_author_meta('ID')).'"><i class="fa fa-user"></i> '.get_the_author().'</a></span>'; }
														$html .= '</div>';
													}
												}

												if($atts['showexcerpt'] === '1')
												{
													$html .= '<div class="cwp-post-main-text-excerpt"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'>';
														if(!empty(get_the_excerpt())) { $html .= get_the_excerpt(); }
														else { $html .= wp_trim_words(get_the_content(), 120); }
													$html .= '</div>';
												}

												if($atts['showcontent'] === '1')
												{
													$html .= '<div class="cwp-post-main-text-content"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'>';
														$html .= get_the_content();
													$html .= '</div>';
												}
												
												if(!empty(get_the_content()) && $atts['showbutton'] === 'yes')
												{
													$html .= '<div class="cwp-post-main-text-buttons">';
														$html .= '<a href="'.get_permalink().'" class="'.$atts['showbuttonstyle'].'" target="'.$atts['showbuttontarget'].'">'.html_entity_decode($atts['showbuttontext']).'</a>';
													$html .= '</div>';
												}
											$html .= '</div>';
										$html .= '</div>';
									}

								$html .= '</div>';
							$html .= '</div>';
						$html .= '</div>';
					$html .= '</div>';
				}

				if($atts['showpagination'] === '1')
				{
					$html .= '<div class="'.$atts['paginationstyle'].'">';
						$html .= paginate_links([
							'type' => 'list',
							'base' => add_query_arg('cwp-bpl-page', '%#%'),
							'format' => '',
							'mid_size' => 1,
							'prev_text' => __('Back', 'cosmic-blocks'),
							'next_text' => __('Next', 'cosmic-blocks'),
							'screen_reader_text' => __('Posts navigation'),
							'total' => $postslist->max_num_pages,
							'current' => $page
						]);
					$html .= '</div>';
				}
			$html .= '</div>';
			
			//$html .= '<pre>'.print_r($postmeta, true).'</pre>';
		}
		
        wp_reset_postdata();
		
		return $html;
	}
	
	function cwp_posts_tiles_shortcode($atts)
	{
		$page = isset($_GET['cwp-bpt-page']) ? abs((int)$_GET['cwp-bpt-page']) : 1;

		$postslist = new WP_Query([
			'posts_per_page' => $atts['postsperpage'],
			'cat' => $atts['selectedcategory'],
			'category__not_in' => $atts['excludedcategory'],
			'paged' => $page,
			'post_type' => 'post',
			'order' => $atts['order'],
			'orderby' => $atts['orderby']
		]);

		// style
		$cwpContentWrapStyle = '';
		if(isset($atts['color'])) { $cwpContentWrapStyle .= 'background:'.$atts['color'].';'; }
		if(isset($atts['boxradiusfix']) && $atts['boxradiusfix'] === '1' && isset($atts['boxradius']) && $atts['boxradius'] >= 0 ) { $cwpContentWrapStyle .= 'border-radius:'.$atts['boxradius'].'px;'; }
		else if(isset($atts['boxradius']) && $atts['boxradius'] > 0 ) { $cwpContentWrapStyle .= 'border-radius:'.$atts['boxradius'].'px;'; }
		if(isset($atts['boxradiusfix']) && $atts['boxradiusfix'] === '1' && isset($atts['boxpadding']) && $atts['boxpadding'] >= 0 ) { $cwpContentWrapStyle .= 'padding:'.$atts['boxpadding'].'px;'; }
		else if(isset($atts['boxpadding']) && $atts['boxpadding'] > 0 ) { $cwpContentWrapStyle .= 'padding:'.$atts['boxpadding'].'px;'; }

		$columns = '1';
		if(!empty($atts['columns'])) { $columns = $atts['columns']; }

		$html = '';
		if($postslist->have_posts())
		{
			$html .= '<div class="cwp-main-wrapper cwp-'.$columns.'-column">';
				while($postslist->have_posts())
				{
					$postslist->the_post(); 
					$postmeta = get_post_meta(get_the_ID());

					$html .= '<div class="cwp-inner-wrap">';
						$html .= '<div class="cwp-content-wrap '.(!empty($atts['color']) ? 'cwp-content-wrap-has-background' : '').'" style="'.$cwpContentWrapStyle.'">';
							$html .= '<div class="cwp-content-wrap-inner">';
								$html .= '<div class="cwp-tile">';

									if($atts['position'] === 'before')
									{
										if($atts['showtitle'] === '1')
										{
											$html .= '<h3'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'>';
												if(!empty(get_the_content())) { $html .= '<a href="'.get_permalink().'">'; }
													$html .= get_the_title();
												if(!empty(get_the_content())) { $html .= '</a>'; }
											$html .= '</h3>';	
										}
										if($atts['showdate'] === '1' || $atts['showauthor'] === '1')
										{
											$html .= '<div class="cwp-post-meta">';
												if($atts['showdate'] === '1') { $html .= '<span class="cwp-post-meta-date"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'><i class="fa fa-calendar"></i> '.date_i18n(get_option('date_format'), get_the_date('U')).'</span>'; }
												if($atts['showdate'] === '1' && $atts['showauthor'] === '1') { $html .= '<span class="cwp-post-meta-sep"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'>|</span>'; }
												if($atts['showauthor'] === '1') { $html .= '<span class="cwp-post-meta-author"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'><a href="'.get_author_posts_url(get_the_author_meta('ID')).'"><i class="fa fa-user"></i> '.get_the_author().'</a></span>'; }
											$html .= '</div>';
										}
									}

									if($atts['showimage'] === '1')
									{
										$html .= '<div class="cwp-post-main">';
											$html .= '<div class="cwp-post-main-image">';
												if(!empty(get_the_content())) { $html .= '<a href="'.get_permalink().'">'; }
													$postUrl = get_the_post_thumbnail_url(get_the_ID(), $atts['imagesize']);
													if($postUrl) { $html .= '<img src="'.$postUrl.'">'; }
													else { $html .= '<img src="'.COSMIC_BLOCKS_PLUGIN_URL.'/assets/images/no-post.jpg">'; }
												if(!empty(get_the_content())) { $html .= '</a>'; }
											$html .= '</div>';
											$html .= '<div class="cwp-post-main-text">';
												if($atts['position'] === 'after')
												{
													if($atts['showtitle'] === '1')
													{
														$html .= '<h3'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'>';
															if(!empty(get_the_content())) { $html .= '<a href="'.get_permalink().'">'; }
																$html .= get_the_title();
															if(!empty(get_the_content())) { $html .= '</a>'; }
														$html .= '</h3>';	
													}
													if($atts['showdate'] === '1' || $atts['showauthor'] === '1')
													{
														$html .= '<div class="cwp-post-meta">';
															if($atts['showdate'] === '1') { $html .= '<span class="cwp-post-meta-date"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'><i class="fa fa-calendar"></i> '.date_i18n(get_option('date_format'), get_the_date('U')).'</span>'; }
															if($atts['showdate'] === '1' && $atts['showauthor'] === '1') { $html .= '<span class="cwp-post-meta-sep"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'>|</span>'; }
															if($atts['showauthor'] === '1') { $html .= '<span class="cwp-post-meta-author"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'><a href="'.get_author_posts_url(get_the_author_meta('ID')).'"><i class="fa fa-user"></i> '.get_the_author().'</a></span>'; }
														$html .= '</div>';
													}
												}

												if($atts['showexcerpt'] === '1')
												{
													$html .= '<div class="cwp-post-main-text-excerpt"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'>';
														if(!empty(get_the_excerpt($event))) { $html .= '<p>'.CosmicBlocks::the_excerpt_max_charlength(get_the_excerpt(), $atts['excerptcharlength']).'</p>'; }
														else { $html .= '<p>'.wp_trim_words(get_the_content(), $atts['excerptcharlength']).'</p>'; }
													$html .= '</div>';
												}

												if(!empty(get_the_content()) && $atts['showbutton'] === 'yes')
												{
													$html .= '<div class="cwp-post-main-text-buttons">';
														$html .= '<a href="'.get_permalink().'" class="'.$atts['showbuttonstyle'].'" target="'.$atts['showbuttontarget'].'">'.html_entity_decode($atts['showbuttontext']).'</a>';
													$html .= '</div>';
												}

											$html .= '</div>';
										$html .= '</div>';
									}
									else
									{
										$html .= '<div class="cwp-post-main">';
											$html .= '<div class="cwp-post-main-text cwp-post-main-text-full">';
												if($atts['position'] === 'after')
												{
													if($atts['showtitle'] === '1')
													{
														$html .= '<h3'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'>';
															if(!empty(get_the_content())) { $html .= '<a href="'.get_permalink().'">'; }
																$html .= get_the_title();
															if(!empty(get_the_content())) { $html .= '</a>'; }
														$html .= '</h3>';	
													}
													if($atts['showdate'] === '1' || $atts['showauthor'] === '1')
													{
														$html .= '<div class="cwp-post-meta">';
															if($atts['showdate'] === '1') { $html .= '<span class="cwp-post-meta-date"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'><i class="fa fa-calendar"></i> '.date_i18n(get_option('date_format'), get_the_date('U')).'</span>'; }
															if($atts['showdate'] === '1' && $atts['showauthor'] === '1') { $html .= '<span class="cwp-post-meta-sep"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'>|</span>'; }
															if($atts['showauthor'] === '1') { $html .= '<span class="cwp-post-meta-author"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'><a href="'.get_author_posts_url(get_the_author_meta('ID')).'"><i class="fa fa-user"></i> '.get_the_author().'</a></span>'; }
														$html .= '</div>';
													}
												}

												if($atts['showexcerpt'] === '1')
												{
													$html .= '<div class="cwp-post-main-text-excerpt"'.(!empty($atts['textcolor']) ? ' style="color:'.$atts['textcolor'].'"' : '').'>';
														if(!empty(get_the_excerpt())) { $html .= get_the_excerpt(); }
														else { $html .= wp_trim_words(get_the_content(), 25); }
													$html .= '</div>';
												}

												if(!empty(get_the_content()) && $atts['showbutton'] === 'yes')
												{
													$html .= '<div class="cwp-post-main-text-buttons">';
														$html .= '<a href="'.get_permalink().'" class="'.$atts['showbuttonstyle'].'" target="'.$atts['showbuttontarget'].'">'.html_entity_decode($atts['showbuttontext']).'</a>';
													$html .= '</div>';
												}
											$html .= '</div>';
										$html .= '</div>';
									}

								$html .= '</div>';
							$html .= '</div>';
						$html .= '</div>';
					$html .= '</div>';
				}

				if($atts['showpagination'] === '1')
				{
					$html .= '<div class="'.$atts['paginationstyle'].'">';
						$html .= paginate_links([
							'type' => 'list',
							'base' => add_query_arg('cwp-bpt-page', '%#%'),
							'format' => '',
							'mid_size' => 1,
							'prev_text' => __('Back', 'cosmic-blocks'),
							'next_text' => __('Next', 'cosmic-blocks'),
							'screen_reader_text' => __('Posts navigation'),
							'total' => $postslist->max_num_pages,
							'current' => $page
						]);
					$html .= '</div>';
				}
			$html .= '</div>';
		}
		
        wp_reset_postdata();
		
		return $html;
	}
}